<?php

/** miniOrange enables user to log in through mobile authentication as an additional layer of security over password.
    Copyright (C) 2015  miniOrange

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
* @package 		miniOrange OAuth
* @license		http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

class moec2f_Utility
{

	function lockedOutlink(){
		if(MOEC2F_IS_ONPREM){
			return moec2f_Constants::OnPremiseLockedOut;
		}else{
			return moec2f_Constants::CloudLockedOut;
		}
	}

	public static function icr() 
	{
		$email 			= get_option('mo2f_email');
		$customerKey 	= get_option('mo2f_customerKey');
		if( ! $email || ! $customerKey || ! is_numeric( trim( $customerKey ) ) )
			return 0;
		else
			return 1;
	}
	
	public static function check_empty_or_null( $value )
	{
		if( ! isset( $value ) || empty( $value ) )
			return true;
		return false;
	}

    public static function rand()
    {
        $length = wp_rand(0, 15);
        $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $randomString = '';
        for ($i = 0; $i < $length; $i++) {
            $randomString .= $characters[wp_rand(0, strlen($characters) - 1)];
        }
        return $randomString;
    }
	
	public static function is_curl_installed()
	{
		if  (in_array  ('curl', get_loaded_extensions()))
			return 1;
		else 
			return 0;
	}
	
	



	
	
	
	public static function getFeatureStatus(){
		$status='';
		$status.="#";
		
		if(get_site_option('mo2f_visit_waf'))
			$status.="WF1";
		if(get_site_option('WAF'))
			$status.="F1";
		if(get_site_option('mo2f_visit_login_and_spam'))
			$status.="LS1";
		if(moec2f_Utility::get_mo2f_db_option('mo2f_enable_brute_force', 'get_option'))
			$status.="BF1";
		if(get_site_option('mo2f_visit_malware'))
			$status.="M1";
		if(get_site_option('mo2f_visit_backup'))
			$status.="B1";
		if(get_site_option('mo2f_two_factor'))
			$status.="TF1";
			
		$status.="R".rand(0,1000);
		return $status;
	}
	function checkPlugins(){
			$installed="";
			$filedirname=dirname(dirname(dirname(__FILE__)));
			if(file_exists($filedirname."/wordfence/wordfence.php")){
				$installed.="wordfence;";
			}
			if(file_exists($filedirname."/all-in-one-wp-security-and-firewall/wp-security.php")){
				$installed.="all-in-one-wp-security-and-firewall;";
			}
			if(file_exists($filedirname."/better-wp-security/better-wp-security.php")){
				$installed.="better-wp-security;";
			}
			if(file_exists($filedirname."/sucuri-scanner/sucuri.php")){
				$installed.="sucuri-scanner;";
			}
			return $installed;
			
		}

	public static function get_mo2f_db_option($value, $type){
		if($type == 'site_option'){
			$db_value = get_site_option($value, $GLOBALS[$value]);
		}else{
			$db_value = get_option($value, $GLOBALS[$value]);
		}
		return $db_value;
	}
	public static function checkSecurity(){

		$guestcustomer = new moec2f_Customer_Setup();

		$guestcustomer->guest_audit();
	}
	
}
